using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace SaveRestoreProperties
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private TIS.Imaging.ICImagingControl icImagingControl1;
		private System.Windows.Forms.Button btnDevice;
		private System.Windows.Forms.Button btnProperties;
		private System.Windows.Forms.Button btnSaveSettings;
		private System.Windows.Forms.Button btnRestoreSettings;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.icImagingControl1 = new TIS.Imaging.ICImagingControl();
            this.btnDevice = new System.Windows.Forms.Button();
            this.btnProperties = new System.Windows.Forms.Button();
            this.btnSaveSettings = new System.Windows.Forms.Button();
            this.btnRestoreSettings = new System.Windows.Forms.Button();
            ((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).BeginInit();
            this.SuspendLayout();
            // 
            // icImagingControl1
            // 
            this.icImagingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.icImagingControl1.BackColor = System.Drawing.Color.White;
            this.icImagingControl1.DeviceListChangedExecutionMode = TIS.Imaging.EventExecutionMode.Invoke;
            this.icImagingControl1.DeviceLostExecutionMode = TIS.Imaging.EventExecutionMode.AsyncInvoke;
            this.icImagingControl1.ImageAvailableExecutionMode = TIS.Imaging.EventExecutionMode.MultiThreaded;
            this.icImagingControl1.LiveDisplayPosition = new System.Drawing.Point(0, 0);
            this.icImagingControl1.Location = new System.Drawing.Point(128, 7);
            this.icImagingControl1.Name = "icImagingControl1";
            this.icImagingControl1.Size = new System.Drawing.Size(304, 249);
            this.icImagingControl1.TabIndex = 0;
            // 
            // btnDevice
            // 
            this.btnDevice.Location = new System.Drawing.Point(8, 7);
            this.btnDevice.Name = "btnDevice";
            this.btnDevice.Size = new System.Drawing.Size(112, 23);
            this.btnDevice.TabIndex = 1;
            this.btnDevice.Text = "Device...";
            this.btnDevice.Click += new System.EventHandler(this.btnDevice_Click);
            // 
            // btnProperties
            // 
            this.btnProperties.Location = new System.Drawing.Point(8, 37);
            this.btnProperties.Name = "btnProperties";
            this.btnProperties.Size = new System.Drawing.Size(112, 22);
            this.btnProperties.TabIndex = 2;
            this.btnProperties.Text = "Properties...";
            this.btnProperties.Click += new System.EventHandler(this.btnProperties_Click);
            // 
            // btnSaveSettings
            // 
            this.btnSaveSettings.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.btnSaveSettings.Location = new System.Drawing.Point(8, 205);
            this.btnSaveSettings.Name = "btnSaveSettings";
            this.btnSaveSettings.Size = new System.Drawing.Size(112, 22);
            this.btnSaveSettings.TabIndex = 3;
            this.btnSaveSettings.Text = "Save Settings...";
            this.btnSaveSettings.Click += new System.EventHandler(this.btnSaveSettings_Click);
            // 
            // btnRestoreSettings
            // 
            this.btnRestoreSettings.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.btnRestoreSettings.Location = new System.Drawing.Point(8, 234);
            this.btnRestoreSettings.Name = "btnRestoreSettings";
            this.btnRestoreSettings.Size = new System.Drawing.Size(112, 22);
            this.btnRestoreSettings.TabIndex = 4;
            this.btnRestoreSettings.Text = "Restore Settings...";
            this.btnRestoreSettings.Click += new System.EventHandler(this.btnRestoreSettings_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
            this.ClientSize = new System.Drawing.Size(440, 262);
            this.Controls.Add(this.btnRestoreSettings);
            this.Controls.Add(this.btnSaveSettings);
            this.Controls.Add(this.btnProperties);
            this.Controls.Add(this.btnDevice);
            this.Controls.Add(this.icImagingControl1);
            this.MinimumSize = new System.Drawing.Size(300, 185);
            this.Name = "Form1";
            this.Text = "Save & Restore Properties";
            ((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void btnDevice_Click(object sender, System.EventArgs e)
		{
			if( icImagingControl1.LiveVideoRunning )
			{
				icImagingControl1.LiveStop();
			}

			icImagingControl1.ShowDeviceSettingsDialog();

			if( icImagingControl1.DeviceValid )
			{
				icImagingControl1.LiveStart();
			}
		}

		private void btnProperties_Click(object sender, System.EventArgs e)
		{
			if( icImagingControl1.DeviceValid )
			{
				icImagingControl1.ShowPropertyDialog();
			}
		}
		
		private void btnSaveSettings_Click(object sender, System.EventArgs e)
		{
			if( icImagingControl1.DeviceValid )
			{
				SaveFileDialog dlg = new SaveFileDialog();
				dlg.AddExtension = true;
				dlg.DefaultExt = "xml";
				dlg.Filter = "Configuration Files (*.xml)|*.xml||";
				dlg.OverwritePrompt = true;
				dlg.RestoreDirectory = true;
				dlg.Title = "Save Settings";

				if( dlg.ShowDialog() == DialogResult.OK )
				{
					icImagingControl1.SaveDeviceStateToFile( dlg.FileName );
				}
			}
		}

		private void btnRestoreSettings_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog dlg = new OpenFileDialog();
			dlg.Filter = "Configuration Files (*.xml)|*.xml||";
			dlg.RestoreDirectory = true;
			dlg.Title = "Restore Settings";

			if( dlg.ShowDialog() == DialogResult.OK )
			{
				try
				{
                    // If a device shows a live video, stop it.
                    if (icImagingControl1.LiveVideoRunning)
                        icImagingControl1.LiveStop();

                    // Load the configuration file.
                    icImagingControl1.LoadDeviceStateFromFile(dlg.FileName, true);

                    // Start the live video again.
                    icImagingControl1.LiveStart();
				}
				catch( TIS.Imaging.ICException ex)
				{
					MessageBox.Show(ex.Message,"Failed to Open Device",MessageBoxButtons.OK, MessageBoxIcon.Warning);
				}
			}

		}
	}
}
